// bncDoc.h : interface of the CBncDoc class
//
/////////////////////////////////////////////////////////////////////////////

class CBncDoc : public CDocument
{
protected: // create from serialization only
	CBncDoc();
	DECLARE_DYNCREATE(CBncDoc)

// Attributes
public:
	// bounce window client area and bouncing ball color/size parameters
	UINT m_nIDColor;
	COLORREF m_clrBall;

	BOOL m_bFastSpeed;          // current speed

	CPoint m_ptPixel;           // pixel size
	CSize m_sizeRadius;         // radius of ball
	CSize m_sizeMove;           // move speed
	CSize m_sizeTotal;          // total size for ball bitmap
	CPoint m_ptCenter;          // current center for the ball

	// for replicating bouncing ball
	CBitmap m_bmBall;

// Operations
public:

	void SetBallColor();
	void SetCustomBallColor(COLORREF clr);
	void SetBallRadius(CSize radius);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBncDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBncDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
// Generated message map functions
protected:
	//{{AFX_MSG(CBncDoc)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
